package com.dsic.gj_erp.bean.fd;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;

/**
 * <p>
 * 
 * </p>
 *
 * @author xhj
 * @since 2023-05-08
 */
@Data
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="DmCzfddyb对象", description="")
public class DmCzfddyb implements Serializable {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "船只编号")
    private String czbh;

    @ApiModelProperty(value = "分段号")
    private String fdh;

    @ApiModelProperty(value = "所属区域")
    private String qy;

    @ApiModelProperty(value = "行")
    private Integer frow;

    @ApiModelProperty(value = "列")
    private Integer fcol;

    @ApiModelProperty(value = "作业单位")
    private String zydw;

    @ApiModelProperty(value = "作业车间")
    private String zycj;

    @ApiModelProperty(value = "上胎计划期")
    private String stjhrq;

    @ApiModelProperty(value = "总组计划期")
    private String zzjhrq;

    @ApiModelProperty(value = "大组计划期")
    private String dzjhrq;

    @ApiModelProperty(value = "小组计划期")
    private String xzjhrq;

    @ApiModelProperty(value = "开工日期")
    private String kgrq;

    @ApiModelProperty(value = "完工日期")
    private String wgrq;

    @ApiModelProperty(value = "托盘总数")
    private Integer tpzs;

    @ApiModelProperty(value = "状态")
    private String zt;

    @ApiModelProperty(value = "备注")
    private String bz;

    @TableId(value = "id", type = IdType.ASSIGN_UUID)
    private String id;



}
