package com.dsic.gj_erp.controller.pgd;


import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jhgk.DmYdjh;
import com.dsic.gj_erp.bean.jhgk.DmYdjhLj;
import com.dsic.gj_erp.bean.zyjh.DmYppyz;
import com.dsic.gj_erp.mapper.pgd.PgdQmjhMapper;
import com.dsic.gj_erp.service.jhgk.DmQfxqService;
import com.dsic.gj_erp.service.jhgk.DmYdjhLjService;
import com.dsic.gj_erp.service.pgd.DmPpxxbService;
import com.dsic.gj_erp.service.zyjh.DmYppyzService;
import lombok.AllArgsConstructor;
import org.apache.commons.lang3.StringUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-12-14
 */
@RestController
@RequestMapping("/dmPpxxb")
@AllArgsConstructor
public class DmPpxxbController {

    private final DmQfxqService qfxqService;
    private final DmPpxxbService ppxxbService;
    private final PgdQmjhMapper pgdQmjhMapper;
    private final DmYdjhLjService dmYdjhLjService;

    private final DmYppyzService dmYppyzService;

//    @PostMapping("getDmppxxbList")
//    public ResultBean<?> getDmppxxbList(@RequestBody DmPpxxb dmPpxxb){
//        List<DmPpxxb> list = ppxxbService.list(Wrappers.<DmPpxxb>lambdaQuery()
//                .eq(DmPpxxb::getDcCh, dmPpxxb.getDcCh())
//                .eq(StrUtil.isNotEmpty(dmPpxxb.getDwh()),DmPpxxb::getDwh, dmPpxxb.getDwh())
//                .eq(StrUtil.isNotEmpty(dmPpxxb.getQy()),DmPpxxb::getQy, dmPpxxb.getQy())
//        );
//        return new ResultBean<>(list);
//    }

    @PostMapping("getDmppxxbList")
    public ResultBean<?> getDmppxxbList(@RequestBody Map map){
        List<DmYdjhLj> dmYdjhLjs = pgdQmjhMapper.selectQmByQgAndJh1(map);
        return new ResultBean<>(dmYdjhLjs);
    }



    @PostMapping("getDmppxxbListAndYz")
    public ResultBean<?> getDmppxxbListAndYz(@RequestBody Map map){
        List<DmYdjhLj> dmYdjhLjs = pgdQmjhMapper.selectQmByQgAndJh1(map);

        /// 查询这条船所有的原则
        List<DmYppyz> list = dmYppyzService.list();
        for(DmYppyz dmYppyz :list){
            if (StringUtils.isNotBlank(dmYppyz.getDcCh()) && StringUtils.isNotBlank(dmYppyz.getDcPl()) && StringUtils.isNotBlank(dmYppyz.getDcFd()) &&
                StringUtils.isNotBlank(dmYppyz.getKw()) && StringUtils.isNotBlank(dmYppyz.getZl()) && StringUtils.isNotBlank(dmYppyz.getTz()) &&
                StringUtils.isNotBlank(dmYppyz.getLx()) && StringUtils.isNotBlank(dmYppyz.getXj())) {
                for(DmYdjhLj dmYdjhLj :dmYdjhLjs){
                    if(dmYppyz.getDcCh().equals(dmYdjhLj.getCzbh()) &&  dmYppyz.getDcPl().equals(dmYdjhLj.getPl()) &&  dmYppyz.getDcFd().equals(dmYdjhLj.getFd()) &&
                        dmYppyz.getKw().equals(dmYdjhLj.getKw()) && dmYppyz.getZl().equals(dmYdjhLj.getZl()) && dmYppyz.getTz().equals(dmYdjhLj.getTz())
                        && dmYppyz.getLx().equals(dmYdjhLj.getLx()) && dmYppyz.getXj().equals(dmYdjhLj.getXj())
                    ){
                        dmYdjhLj.setYpph(dmYppyz.getYpph());
                        dmYdjhLj.setYzDcCh(dmYppyz.getDcCh());
                        dmYdjhLj.setYzDcPl(dmYppyz.getDcPl());
                        dmYdjhLj.setYzDcFd(dmYppyz.getDcFd());
                        dmYdjhLj.setYzkw(dmYppyz.getKw());
                        dmYdjhLj.setYzZl(dmYppyz.getZl());
                        dmYdjhLj.setYzTz(dmYppyz.getTz());
                        dmYdjhLj.setYzLx(dmYppyz.getLx());
                        dmYdjhLj.setYzXj(dmYppyz.getXj());
                    }
                }


            } else if (StringUtils.isNotBlank(dmYppyz.getDcCh()) && StringUtils.isNotBlank(dmYppyz.getDcPl()) && StringUtils.isNotBlank(dmYppyz.getDcFd()) &&
                StringUtils.isNotBlank(dmYppyz.getKw()) && StringUtils.isNotBlank(dmYppyz.getZl()) && StringUtils.isNotBlank(dmYppyz.getTz()) &&
                StringUtils.isNotBlank(dmYppyz.getLx())) {

                for(DmYdjhLj dmYdjhLj :dmYdjhLjs){
                    if(dmYppyz.getDcCh().equals(dmYdjhLj.getCzbh()) &&  dmYppyz.getDcPl().equals(dmYdjhLj.getPl()) &&  dmYppyz.getDcFd().equals(dmYdjhLj.getFd()) &&
                        dmYppyz.getKw().equals(dmYdjhLj.getKw()) && dmYppyz.getZl().equals(dmYdjhLj.getZl()) && dmYppyz.getTz().equals(dmYdjhLj.getTz())
                        && dmYppyz.getLx().equals(dmYdjhLj.getLx())
                    ){
                        dmYdjhLj.setYpph(dmYppyz.getYpph());
                        dmYdjhLj.setYzDcCh(dmYppyz.getDcCh());
                        dmYdjhLj.setYzDcPl(dmYppyz.getDcPl());
                        dmYdjhLj.setYzDcFd(dmYppyz.getDcFd());
                        dmYdjhLj.setYzkw(dmYppyz.getKw());
                        dmYdjhLj.setYzZl(dmYppyz.getZl());
                        dmYdjhLj.setYzTz(dmYppyz.getTz());
                        dmYdjhLj.setYzLx(dmYppyz.getLx());
                    }
                }

            } else if (StringUtils.isNotBlank(dmYppyz.getDcCh()) && StringUtils.isNotBlank(dmYppyz.getDcPl()) && StringUtils.isNotBlank(dmYppyz.getDcFd()) &&
                StringUtils.isNotBlank(dmYppyz.getKw()) && StringUtils.isNotBlank(dmYppyz.getZl()) && StringUtils.isNotBlank(dmYppyz.getTz())) {
                for(DmYdjhLj dmYdjhLj :dmYdjhLjs){
                    if(dmYppyz.getDcCh().equals(dmYdjhLj.getCzbh()) &&  dmYppyz.getDcPl().equals(dmYdjhLj.getPl()) &&  dmYppyz.getDcFd().equals(dmYdjhLj.getFd()) &&
                        dmYppyz.getKw().equals(dmYdjhLj.getKw()) && dmYppyz.getZl().equals(dmYdjhLj.getZl()) && dmYppyz.getTz().equals(dmYdjhLj.getTz())

                    ){
                        dmYdjhLj.setYpph(dmYppyz.getYpph());
                        dmYdjhLj.setYzDcCh(dmYppyz.getDcCh());
                        dmYdjhLj.setYzDcPl(dmYppyz.getDcPl());
                        dmYdjhLj.setYzDcFd(dmYppyz.getDcFd());
                        dmYdjhLj.setYzkw(dmYppyz.getKw());
                        dmYdjhLj.setYzZl(dmYppyz.getZl());
                        dmYdjhLj.setYzTz(dmYppyz.getTz());
                    }
                }

            } else if (StringUtils.isNotBlank(dmYppyz.getDcCh()) && StringUtils.isNotBlank(dmYppyz.getDcPl()) && StringUtils.isNotBlank(dmYppyz.getDcFd()) &&
                StringUtils.isNotBlank(dmYppyz.getKw()) && StringUtils.isNotBlank(dmYppyz.getZl())) {
                for(DmYdjhLj dmYdjhLj :dmYdjhLjs){
                    if(dmYppyz.getDcCh().equals(dmYdjhLj.getCzbh()) &&  dmYppyz.getDcPl().equals(dmYdjhLj.getPl()) &&  dmYppyz.getDcFd().equals(dmYdjhLj.getFd()) &&
                        dmYppyz.getKw().equals(dmYdjhLj.getKw()) && dmYppyz.getZl().equals(dmYdjhLj.getZl())

                    ){
                        dmYdjhLj.setYpph(dmYppyz.getYpph());
                        dmYdjhLj.setYzDcCh(dmYppyz.getDcCh());
                        dmYdjhLj.setYzDcPl(dmYppyz.getDcPl());
                        dmYdjhLj.setYzDcFd(dmYppyz.getDcFd());
                        dmYdjhLj.setYzkw(dmYppyz.getKw());
                        dmYdjhLj.setYzZl(dmYppyz.getZl());
                    }
                }
            } else if (StringUtils.isNotBlank(dmYppyz.getDcCh()) && StringUtils.isNotBlank(dmYppyz.getDcPl()) && StringUtils.isNotBlank(dmYppyz.getDcFd()) &&
                StringUtils.isNotBlank(dmYppyz.getKw())) {

                for(DmYdjhLj dmYdjhLj :dmYdjhLjs){
                    if(dmYppyz.getDcCh().equals(dmYdjhLj.getCzbh()) &&  dmYppyz.getDcPl().equals(dmYdjhLj.getPl()) &&  dmYppyz.getDcFd().equals(dmYdjhLj.getFd()) &&
                        dmYppyz.getKw().equals(dmYdjhLj.getKw())

                    ){
                        dmYdjhLj.setYpph(dmYppyz.getYpph());
                        dmYdjhLj.setYzDcCh(dmYppyz.getDcCh());
                        dmYdjhLj.setYzDcPl(dmYppyz.getDcPl());
                        dmYdjhLj.setYzDcFd(dmYppyz.getDcFd());
                        dmYdjhLj.setYzkw(dmYppyz.getKw());
                    }
                }

            } else if (StringUtils.isNotBlank(dmYppyz.getDcCh()) && StringUtils.isNotBlank(dmYppyz.getDcPl()) && StringUtils.isNotBlank(dmYppyz.getDcFd())) {
                for(DmYdjhLj dmYdjhLj :dmYdjhLjs){
                    if(dmYppyz.getDcCh().equals(dmYdjhLj.getCzbh()) &&  dmYppyz.getDcPl().equals(dmYdjhLj.getPl()) &&  dmYppyz.getDcFd().equals(dmYdjhLj.getFd())

                    ){
                        dmYdjhLj.setYpph(dmYppyz.getYpph());
                        dmYdjhLj.setYzDcCh(dmYppyz.getDcCh());
                        dmYdjhLj.setYzDcPl(dmYppyz.getDcPl());
                        dmYdjhLj.setYzDcFd(dmYppyz.getDcFd());
                    }
                }
            } else if (StringUtils.isNotBlank(dmYppyz.getDcCh()) && StringUtils.isNotBlank(dmYppyz.getDcPl())) {
                for(DmYdjhLj dmYdjhLj :dmYdjhLjs){
                    if(dmYppyz.getDcCh().equals(dmYdjhLj.getCzbh()) &&  dmYppyz.getDcPl().equals(dmYdjhLj.getPl())

                    ){
                        dmYdjhLj.setYpph(dmYppyz.getYpph());
                        dmYdjhLj.setYzDcCh(dmYppyz.getDcCh());
                        dmYdjhLj.setYzDcPl(dmYppyz.getDcPl());
                    }
                }

            } else if (StringUtils.isNotBlank(dmYppyz.getDcCh())) {
                for(DmYdjhLj dmYdjhLj :dmYdjhLjs){
                    if(dmYppyz.getDcCh().equals(dmYdjhLj.getCzbh())

                    ){
                        dmYdjhLj.setYpph(dmYppyz.getYpph());
                        dmYdjhLj.setYzDcCh(dmYppyz.getDcCh());
                    }
                }
            }
        }

        return new ResultBean<>(dmYdjhLjs);
    }


    @PostMapping("saveDmppxxb")
    @Transactional(rollbackFor = Exception.class)
    public ResultBean<?> save(@RequestBody List<DmYdjhLj> list){
        List<DmYdjhLj>adds =new ArrayList<>();
        list.forEach(e->{
            DmYdjhLj dmYdjhLj= new DmYdjhLj();
                dmYdjhLj.setId(e.getId());
                dmYdjhLj.setQq(e.getQq());
                dmYdjhLj.setDw(e.getDw());
                dmYdjhLj.setPpzt("02");
            adds.add(dmYdjhLj);
        });
        dmYdjhLjService.updateBatchById(adds);

//        list.forEach(item-> item.setZt("00"));
//        ppxxbService.saveOrUpdateBatchByMultiId(list);
        return new ResultBean<>();
    }


    @PostMapping("saveDmppxxbpg")
    @Transactional(rollbackFor = Exception.class)
    @AuthFunction
    public ResultBean<?> saveDmppxxbpg(@RequestBody List<DmYdjhLj> list, HttpServletRequest request){
        String bzry= (String) request.getAttribute("yhms");
        String bzrq= DateUtil.format(DateUtil.date(), "yyyy/MM/dd");
        List<DmYdjhLj>adds =new ArrayList<>();
        list.forEach(e->{
            DmYdjhLj dmYdjhLj= new DmYdjhLj();
            dmYdjhLj.setId(e.getId());
            dmYdjhLj.setPpzt("03");
            dmYdjhLj.setRkry(bzry);
            dmYdjhLj.setRkrq(bzrq);
            adds.add(dmYdjhLj);
        });
        dmYdjhLjService.updateBatchById(adds);

//        list.forEach(item-> item.setZt("00"));
//        ppxxbService.saveOrUpdateBatchByMultiId(list);
        return new ResultBean<>();
    }

    @PostMapping("saveDmppxxbqr")
    @Transactional(rollbackFor = Exception.class)
    @AuthFunction
    public ResultBean<?> saveDmppxxbqr(@RequestBody List<DmYdjhLj> list, HttpServletRequest request){
        String bzry= (String) request.getAttribute("yhms");
        String bzrq= DateUtil.format(DateUtil.date(), "yyyy/MM/dd");
        List<DmYdjhLj>adds =new ArrayList<>();
        list.forEach(e->{
            DmYdjhLj dmYdjhLj= new DmYdjhLj();
            dmYdjhLj.setId(e.getId());
            dmYdjhLj.setPpzt("04");
            dmYdjhLj.setQrry(bzry);
            dmYdjhLj.setQrrq(bzrq);
            adds.add(dmYdjhLj);
        });
        dmYdjhLjService.updateBatchById(adds);

//        list.forEach(item-> item.setZt("00"));
//        ppxxbService.saveOrUpdateBatchByMultiId(list);
        return new ResultBean<>();
    }

}

